---
AWSTemplateFormatVersion: "2010-09-09"
Description: "Creates a VPC peering connection of specified VPCs in same AWS Account"
Parameters:
  EnvironmentAbbr:
    Description: "Environment abbreviation"
    Type       : "String"

Conditions:
  # Source VPC conditions
  SourceHasPublicSubnets:
    Fn::Equals:
      - {{ 'SubnetsPublic' in vpc_peers[environment_abbr + '-vpc']['stack_outputs'] }}
      - True
  SourceHasDatabaseSubnets:
    Fn::Equals:
      - {{ 'SubnetsDatabase' in vpc_peers[environment_abbr + '-vpc']['stack_outputs']}}
      - True
  SourceHasPrivateSubnets:
    Fn::Equals:
      - {{ 'SubnetsPrivate' in vpc_peers[environment_abbr + '-vpc']['stack_outputs']}}
      - True
{% for peer in aws_vpc_peering_params.peers %}
  # {{ peer.environment_abbr }} VPC conditions
  {{ peer.environment_abbr }}HasPublicSubnets:
    Fn::Equals:
      - {{ 'SubnetsPublic' in vpc_peers[peer.environment_abbr + '-vpc']['stack_outputs']}}
      - True
  {{ peer.environment_abbr }}HasDatabaseSubnets:
    Fn::Equals:
      - {{ 'SubnetsDatabase' in vpc_peers[peer.environment_abbr + '-vpc']['stack_outputs']}}
      - True
  {{ peer.environment_abbr }}HasPrivateSubnets:
    Fn::Equals:
      - {{ 'SubnetsPrivate' in vpc_peers[peer.environment_abbr + '-vpc']['stack_outputs']}}
      - True
{% endfor %}

Resources:
{% for peer in aws_vpc_peering_params.peers %}
#########################################
#                                       #
# Peering connection to {{ peer.environment_abbr }}
#                                       #
#########################################
  VpcPeering{{ peer.region | capitalize | replace('-', '') }}{{ peer.environment_abbr | capitalize | replace('-', '') }}:
    Type: "AWS::EC2::VPCPeeringConnection"
    Properties:
      VpcId:
        Fn::ImportValue: !Sub "${EnvironmentAbbr}-vpc-VpcId"
      PeerVpcId: {{ vpc_peers[peer.environment_abbr + '-vpc']['stack_outputs'].VpcId }}
      PeerRegion: {{ peer.region }}
      Tags:
        - Key: "Name"
          Value: !Sub "${EnvironmentAbbr}-to-{{ peer.environment_abbr }}"

#########################################
#                                       #
# Routes on source VPC                  #
#                                       #
#########################################
  VPCPeer{{ peer.region | capitalize | replace('-', '') }}{{ environment_abbr | capitalize | replace('-', '') }}To{{ peer.environment_abbr | capitalize | replace('-', '') }}RoutePublic:
    Type: "AWS::EC2::Route"
    Condition: "SourceHasPublicSubnets"
    Properties:
      DestinationCidrBlock: {{ vpc_peers[peer.environment_abbr + '-vpc']['stack_outputs'].VpcNetwork }}
      RouteTableId:
        Fn::ImportValue: !Sub "${EnvironmentAbbr}-vpc-RouteTablePublicID"
      VpcPeeringConnectionId: !Ref VpcPeering{{ peer.region | capitalize | replace('-', '') }}{{ peer.environment_abbr | capitalize | replace('-', '') }}
{% for az in peering_azlist %}
  VPCPeer{{ peer.region | capitalize | replace('-', '') }}{{ environment_abbr | capitalize | replace('-', '') }}To{{ peer.environment_abbr | capitalize | replace('-', '') }}RoutePrivate{{ loop.index }}:
    Type: "AWS::EC2::Route"
    Condition: "SourceHasPrivateSubnets"
    Properties:
      DestinationCidrBlock: {{ vpc_peers[peer.environment_abbr + '-vpc']['stack_outputs'].VpcNetwork }}
      RouteTableId:
        Fn::ImportValue: !Sub "${EnvironmentAbbr}-vpc-RouteTablePrivate{{ loop.index }}ID"
      VpcPeeringConnectionId: !Ref VpcPeering{{ peer.region | capitalize | replace('-', '') }}{{ peer.environment_abbr | capitalize | replace('-', '') }}
  VPCPeer{{ peer.region | capitalize | replace('-', '') }}{{ environment_abbr | capitalize | replace('-', '') }}To{{ peer.environment_abbr | capitalize | replace('-', '') }}RouteDatabase{{ loop.index }}:
    Type: "AWS::EC2::Route"
    Condition: "SourceHasDatabaseSubnets"
    Properties:
      DestinationCidrBlock: {{ vpc_peers[peer.environment_abbr + '-vpc']['stack_outputs'].VpcNetwork }}
      RouteTableId:
        Fn::ImportValue: !Sub "${EnvironmentAbbr}-vpc-RouteTableDatabase{{ loop.index }}ID"
      VpcPeeringConnectionId: !Ref VpcPeering{{ peer.region | capitalize | replace('-', '') }}{{ peer.environment_abbr | capitalize | replace('-', '') }}

{% endfor %}

#########################################
#                                       #
# ACLs on source VPC                    #
#                                       #
#########################################
{% set count = 100 + loop.index0 %}
  AclInPeer{{ environment_abbr | capitalize | replace('-', '') }}From{{ peer.region | capitalize | replace('-', '') }}{{ peer.environment_abbr | capitalize | replace('-', '') }}PublicTCPEphemeral:
    Type: "AWS::EC2::NetworkAclEntry"
    Condition: "SourceHasPublicSubnets"
    Properties:
      RuleNumber: "{{ count }}"
      Protocol: 6
      CidrBlock: {{ vpc_peers[peer.environment_abbr + '-vpc']['stack_outputs'].VpcNetwork }}
      PortRange:
        From: 1025
        To: 65535
      RuleAction: "allow"
      NetworkAclId:
        Fn::ImportValue: !Sub "${EnvironmentAbbr}-vpc-AclPublicID"
  AclInPeer{{ environment_abbr | capitalize | replace('-', '') }}From{{ peer.region | capitalize | replace('-', '') }}{{ peer.environment_abbr | capitalize | replace('-', '') }}PrivateTCPEphemeral:
    Type: "AWS::EC2::NetworkAclEntry"
    Condition: "SourceHasPrivateSubnets"
    Properties:
      RuleNumber: "{{ count }}"
      Protocol: 6
      CidrBlock: {{ vpc_peers[peer.environment_abbr + '-vpc']['stack_outputs'].VpcNetwork }}
      PortRange:
        From: 1025
        To: 65535
      RuleAction: "allow"
      NetworkAclId:
        Fn::ImportValue: !Sub "${EnvironmentAbbr}-vpc-AclPrivateID"
  AclInPeer{{ environment_abbr | capitalize | replace('-', '') }}From{{ peer.region | capitalize | replace('-', '') }}{{ peer.environment_abbr | capitalize | replace('-', '') }}DatabaseTCPEphemeral:
    Type: "AWS::EC2::NetworkAclEntry"
    Condition: "SourceHasDatabaseSubnets"
    Properties:
      RuleNumber: "{{ count }}"
      Protocol: 6
      CidrBlock: {{ vpc_peers[peer.environment_abbr + '-vpc']['stack_outputs'].VpcNetwork }}
      PortRange:
        From: 1025
        To: 65535
      RuleAction: "allow"
      NetworkAclId:
        Fn::ImportValue: !Sub "${EnvironmentAbbr}-vpc-AclDatabaseID"
{% endfor %}

Outputs:
{% for peer in aws_vpc_peering_params.peers %}
  VpcPeeringId{{ peer.region | capitalize | replace('-', '') }}{{ peer.environment_abbr | capitalize | replace('-', '') }}:
    Value: !Ref "VpcPeering{{ peer.region | capitalize | replace('-', '') }}{{ peer.environment_abbr | capitalize | replace('-', '') }}"
    Description: "VPC Peer ID"
{% endfor %}
